(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
                Tableau de toutes les couleurs du mode texte 03h            
                        Tapez F1 pour afficher l'aide                       
Ĵ
  Version                                                                 
                                                                 
                                                                            
 18/08/2000 => Version 1.2                                                  
    + Possibilit d'avtiver/dsavtiver le clignotement du texte             
    - La couleur slctionne ne clignote plus                              
 24/03/2000 => Version 1.1.2                                                
    - N'initialise plus le mode texte compltement (plus de InitModeTxt)    
     (car rinitialise mon nouvel cran Iiyama Vision Master Pro 410, 17'') 
 14/02/1999 => Version 1.1.1                                                
    + Appel 'InitModeTxt' au dmarrage                                      
    * Correction du texte de test (j'ai chang d'email)                     
 24/11/1998 => Version 1.1                                                  
    - Deboggage de la procdure 'Clignotement' (dans OptVideo.tpu)          
 27/11/1998 => Version 1.0                                                  
    + Insertion de l'aide                                                   
    + Affichage de la couleur dans le titre par la couleur de fond puis la  
      couleur du texte.                                                     
 11/10/1998 => Version 0.9 (dbut de l'insription des modifs)               
*)

{$M 2048,0,0}

uses
  Clavier,    { Pour le clavier (LitTouche) }
  EcranTxt,   { Pour l'cran texte (affichage de texte en couleur) }
  FaitPaus,   { Pour faire des pauses }
  OptVideo;   { Pour les fonctions vidos spciales }

type
  AideTxt = record X: shortint; Coul: byte; txt: string[74] end;

const
  Version = '1.2';
  Email   = 'haypo@ifrance.com';
  PageWeb = 'http://www.multimania.com/haypo/';

  TxtDemo = '<- CoulText est un programme de Haypo ('+Email+') ->';
  TxtAide = 'F1: Aide';
  CoulCadr = 9+0*16;
  CadrX = 10; CadrY = 1;

  ListeTouche: array[1..23] of AideTxt = (
(X: 0;Coul: 0;Txt:''),
(X: 3;Coul:14;Txt:'Informations'),
(X: 3;Coul:14;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 2;Coul:15;Txt:'''CoulText'' est un utilitaire de Haypo ('+Email+') qui permet'),
(X: 1;Coul:15;Txt:'de visualiser toutes les couleurs de mode texte (03h).'),
(X: 1;Coul:15;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 3;Coul:14;Txt:'Touches utilises'),
(X: 3;Coul:14;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'Gauche/Droite : Change de couleur'),
(X: 1;Coul:15;Txt:'Haut/Bas .... : Idem mais 16 par 16'),
(X: 1;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'Espace ...... : Inverse la couleur actuelle'),
(X: 1;Coul:15;Txt:'Ente ....... : Active/Dsactive les couleurs de fond clignotantes'),
(X: 0;Coul: 0;Txt:''),
(X: 1;Coul:15;Txt:'F1 .......... : Affiche l''aide'),
(X: 1;Coul:15;Txt:'Echape ...... : Quitte  CoulText '+Version+' '),
(X: 0;Coul: 0;Txt:''),
(X:-1;Coul: 7;Txt:'- Enfoncez une touche pour revenir -'),
(X: 0;Coul: 0;Txt:''));

var
  txt,txt2: string;
  i,vram: word;
  ix,iy ,Coul,CoulIndex: byte;
  Clign: boolean;
  key: char;

procedure Deplace (plus: integer); var i,vram: word; begin
  plus := CoulIndex +plus;
  if plus<0 then inc(plus,256);
  if 255<plus then dec(plus,256);

  { Remet la CoulIndexeur originale de l'index dans le tableau }
  ColoriH (CadrX+1 +CoulIndex and 15 shl 2,CadrY+3 +CoulIndex shr 4,4,CoulIndex);

  AttendEcran;
  EcriTxhc ((80-length(txt)) shr 1,CadrY,length(txt),ChLigneH,CoulCadr);
  CoulIndex := plus;
  Str (CoulIndex,txt); txt := 'Couleur n'+txt;
  Str (CoulIndex and 15,txt2); txt := txt+' ('+txt2+'+';
  Str (CoulIndex shr  4,txt2); txt := txt+txt2+'*16)';
  txt := ' '+txt+' ';
  EcriTxc ((80-length(txt)) shr 1,CadrY,txt,14+0*16);
  EcriTxc ((80-length(TxtDemo)) shr 1,22,TxtDemo,CoulIndex);
  EcriTxc (80-length(TxtAide),24,TxtAide,7+0*16);

  { Change la CoulIndexeur de fond }
  vram := 0;
  for i := 0 to 1999 do begin
    if EcrnTxt[vram]=0 then EcrnTxt[vram+1] := CoulIndex;
    inc (vram,2);
  end;

  { Colorie l'index de la CoulIndexeur dans le tableau }
  ColoriH (CadrX+1 +CoulIndex and 15 shl 2,CadrY+3 +CoulIndex shr 4,4,not CoulIndex);
end;

procedure AfficheListeTouche; var min,max: byte; begin
  VideTamponClavier;

  { Ecrit l'aide dans le Double-Buffer (page 2 de la mmoire vido) }
  CoulTxt :=  9+1*16; vram := 0;
  for i := 0 to 1999 do begin
    SavEcrnTxt[vram] := Ord(' '); inc (vram);
    SavEcrnTxt[vram] := CoulTxt; inc (vram);
  end;

  Vram := 0;
  SavEcrnTxt[0] := ord(ChDCoinHG);
  for ix := 1 to 78 do SavEcrnTxt[ix shl 1] := Ord(ChDLigneH);
  SavEcrnTxt[158] := ord(ChDCoinHD);
  vram := 24*160;
  SavEcrnTxt[vram] := ord(ChDCoinBG);
  for ix := 1 to 78 do SavEcrnTxt[vram +ix shl 1] := Ord(ChDLigneH);
  SavEcrnTxt[vram+158] := ord(ChDCoinBD);

  vram := 160;
  for iy := 1 to 23 do with ListeTouche[iy] do begin
    vram := iy shl 7 + iy shl 5;
    SavEcrnTxt[vram] := ord(ChDLigneV); inc (vram,2);

    if X<0 then begin
      min := (80-length(txt)) shr 1;
      max := min +length(txt);
    end else if X=0 then begin
      min := 0;
      max := 0;
    end else begin
      min := X;
      max := min +length(txt);
    end;

    inc (vram,min*2);
    for ix := min+1 to max do begin
      SavEcrnTxt[vram] := ord(Txt[ix-min]);      inc (vram);
      SavEcrnTxt[vram] := Coul +CoulTxt and $F0; inc (vram);
    end;
    inc (vram,(78-max)*2);

    SavEcrnTxt[vram] := ord(ChDLigneV);
  end;

  { Scrolle l'cran vers le double-buffer (page 0 -> 1) }
  vram := 0;
  for i := 0 to 25 do begin
    AttendEcran;
    ChangeDebutAffich (vram);
    inc (vram,80);
  end;

  LitTouche;

  { Scrolle le double-buffer vers l'cran (page 1 -> 0) }
  for iy := 0 to 25 do begin
    dec (vram,80);
    AttendEcran;
    ChangeDebutAffich (vram);
  end;
end;

procedure Fin; begin
  InitModeTxt;
  EcriTc ('CoulText',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  SauteLigne;
  Halt;
end;

begin
  EffaceEcranChr (#0,4*16); CurseurOff;
  Clign := FALSE; Clignotement (Clign);

  { Dessin du cadre }
  DessineCadre (CadrX,CadrY,66,3,0,CoulCadr);
  DessineCadre (CadrX-5,CadrY+2,6,18,0,CoulCadr);
  DessineCadre (CadrX,CadrY,66,20,0,CoulCadr);
  EcriTxc (CadrX,CadrY+2,'',CoulCadr);
  EcriTxc (CadrX+65,CadrY+2,'',CoulCadr);
  EcriTxc (CadrX,CadrY+19,'',CoulCadr);

  { Ecrit les numros de couleur }
  for ix := 0 to 15 do begin
    if ix and 1=0 then coul := 15+1*16 else coul := 14+2*16;
    str (ix:2,txt); txt := ' '+txt+' ';
    EcriTxc (CadrX+1+ix*4,CadrY+1,txt,coul);
    EcriTxc (CadrX-4,CadrY+3+ix,txt,coul);
  end;

  for ix := 0 to 15 do begin
    for iy := 0 to 15 do begin
      str (ix+iy*16,txt); while length(txt)<4 do txt := ' '+txt;
      EcriTxc (CadrX+1+ix*4,CadrY+3+iy,txt,ix+iy shl 4);
    end;
  end;

  CoulIndex := 14+1*16; txt := ''; Deplace (+0);
  repeat
    if TouchPresse then begin
      key := LitTouche;

      Case key of
      _ESPACE: Deplace (255-2*CoulIndex);
      _ENTREE: begin Clign := not Clign; Clignotement (Clign) end;
      _GAUCHE: Deplace (-1);
      _HAUT  : Deplace (-16);
      _DROITE: Deplace (+1);
      _BAS   : Deplace (+16);
      _F1    : AfficheListeTouche;
      end;
    end;
  until key=_ECHAPE;

  Fin;
end.
